pipeline {
    agent any
    environment {
        NEW_VERSION = '1.3.0'
        BUILD_NAME = 'leet code'

    }
    stages {
      stage("Build") {
           when {
                expression {
                   return BRANCH_NAME == 'main'  // Custom expression for branch check
                }
            }
            steps {
                 echo "Building on main branch"
                }
        }
        stage("TEST") {
            steps {
                script {
                    if (BRANCH_NAME == 'main') {  // Correct check for lowercase 'main'
                        echo "Testing main branch"
                        echo "Build number is ${BUILD_NUMBER}"  // Print build number for 'main'
                    } else {
                        echo "Testing other branch"
                    }
                }
            }
        }
        stage("Deploy") {
            when {
                expression {
                    return BRANCH_NAME != 'MAYUR'  // Correct use of expression block
                }
            }
            steps {
                echo "Deploying on prod ${NEW_VERSION}"
            }
        }
        stage("Master") {
            when {
                expression {
                    return BRANCH_NAME != 'MAYUR'  // Correct use of expression block
                }
            }
            steps {
                echo "Deploying on prod ${NEW_VERSION}"
            }
        }
    }
    post {
    success {
        echo 'Build succeeded!'
    }
    failure {
        echo 'Build failed!'
    }
}

}